package ch.ethz.inf.vs.nethz.androidtutorial;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.widget.ProgressBar;
import android.widget.TextView;

public class WorkerActivity extends AppCompatActivity {

    private ProgressBar progressBar;
    private TextView textView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_worker);

        progressBar = (ProgressBar) findViewById(R.id.progress_bar);
        textView = (TextView) findViewById(R.id.txt_progress);

        new MyWorker().execute(20);
    }

    public static int calculateProgress(int index, int max) {
        return index * 100 / max;
    }

    class MyWorker extends AsyncTask<Integer, Integer, Void> {
        private int progress;
        @Override
        protected void onPreExecute() {
            progressBar.setMax(100);
            progressBar.setProgress(0);
        }

        @Override
        protected Void doInBackground(Integer... params) {
            for (int i = 0; i < params[0]; i++) {
                try {
                    Thread.sleep(100);
                } catch (InterruptedException e) { }
                publishProgress(i, params[0]); // run onProgressUpdate on UI thread
            }
            return null;
        }

        @Override
        protected void onProgressUpdate(final Integer... values) {
            progress = calculateProgress(values[0], values[1]);
            Log.d("###", Integer.toString(progress));
            textView.setText(Integer.toString(progress));
            progressBar.incrementProgressBy(progress);
        }

        @Override
        protected void onPostExecute(final Void result) {
            textView.setText(R.string.done);
        }
    }
}
